'***********************************************************************
'*  Name    : Si5351A.BAS                                              *
'*  Author  : Les with minor modifications from others                 *
'*  Notice  : Copyright (c) 2016 [select VIEW...EDITOR OPTIONS]        *
'*          : All Rights Reserved.                                     *
'*          : See thread                                               *
'*          :http://www.protonbasic.co.uk/showthread.php/72627-Si5351A *
'*  Date    : 13/04/2016                                               *
'*  Version : 1.0                                                      *
'*  Notes   : frequency synthesiser si5351A                            *
'*          : adjust cXTAL_FREQ to calibrate                           *
'***********************************************************************

'Config
;-------------------------------------------------------------------------------
;**** Added by Fuse Configurator ****
; Use the Fuse Configurator plug-in to change these settings

Device = 16F1827

Declare Reminders Off
@ CONFIG_REQ = 0 ; Override Compiler's configuration settings
Asm-
__Config _Config1, 0x09E4 ;FOSC_INTOSC & WDTE_OFF & PWRTE_OFF & MCLRE_ON & CP_OFF & CPD_OFF & BOREN_OFF & CLKOUTEN_OFF & IESO_OFF & FCMEN_OFF 
__Config _Config2, 0x1CFF ;WRT_OFF & PLLEN_ON & STVREN_OFF & BORV_LO & LVP_OFF 
Endasm-
Declare Reminders On

;**** End of Fuse Configurator Settings ****
;-------------------------------------------------------------------------------

    Declare Xtal = 16
    OSCCON = %11111000            'osccon to 16MHz with PLL on 
    ANSELA = %00000000            'all port a as digital 
    ANSELB = %00000000            'port b as digital

    TRISA = %11100000             'A.5 is MCLR, A.6 is pin 15 and will be the up button, A.7 on pin16 will be down
    TRISB = %00000000             'all outputs 
    
    Declare Optimiser_Level = 2
    Declare Dead_Code_Remove = 1
    Declare Bootloader = off
     
    Declare SDA_Pin PORTB.0      'may need adjustment
    Declare SCL_Pin PORTB.1
    Declare Slow_Bus On

    Declare LCD_CommandUs 2000
    Declare LCD_DataUs 50
    
    Symbol Up = PORTA.6           'UP button
    Symbol Down = PORTA.7         'Down button  
                             
'setup LCD
    Declare LCD_Type 0	          'text type
    Declare LCD_DTPin PORTB.4     'assigns data lines to B4..7  
    Declare LCD_ENPin PORTB.3     'enable pin
    Declare LCD_RSPin PORTB.2     'RS line pin
    Declare LCD_Interface 4	      '4 or 8 input line interface
    Declare LCD_Lines 2           '2 line display
    
    'put the wanted frequencies in eedata
Start_Freq EData Dword  12166667, 14100000, 7100000, 146000000, 147000000, 35775000, 146500000, 10240000, 10695000    
    Dim NoOfFreq   As Byte
    NoOfFreq = 9                  'set this to the number of entries in the Edata table
    
    'To establish the data in high memory of the PIC
    
    $define cSI_CLK0_CONTROL     16              ' Register definitions
    $define cSI_CLK1_CONTROL     17
    $define cSI_CLK2_CONTROL     18
    $define cSI_SYNTH_PLL_A      26
    $define cSI_SYNTH_PLL_B      34
    $define cSI_SYNTH_MS_0       42
    $define cSI_SYNTH_MS_1       50
    $define cSI_SYNTH_MS_2       58
    $define cSI_PLL_RESET        177
    
    $define cSI_R_DIV_1          %00000000       ' R-division ratio definitions
    $define cSI_R_DIV_2          %00010000
    $define cSI_R_DIV_4          %00100000
    $define cSI_R_DIV_8          %00110000
    $define cSI_R_DIV_16         %01000000
    $define cSI_R_DIV_32         %01010000
    $define cSI_R_DIV_64         %01100000
    $define cSI_R_DIV_128        %01110000


    $define cSI_CLK_SRC_PLL_A    %00000000
    $define cSI_CLK_SRC_PLL_B    %00100000


    $define cXTAL_FREQ          24999610        ' Crystal frequency  was 24999480


    $define cI2C_WRITE          %11000000       ' I2C address for writing to the Si5351A
    $define cI2C_READ           %11000001       ' I2C address for reading to the Si5351A
    


    Dim dP1                     As Dword        ' Synth config register P1
    Dim dP2 As Dword                            ' Synth config register P2
    Dim dP3 As Dword                            ' Synth config register P3


    Dim bI2CRegister_Reg        As Byte
    Dim bI2CRegister_Data       As Byte


    Dim bOutputOff_Clk          As Byte


    Dim bSetupMultisynth_Synth  As Byte
    Dim dSetupMultisynth_Divider As Dword
    Dim bSetupMultisynth_Div    As Byte
    Dim Dummy1                  As Word
    Dim Dummy2                  As Word
    Dim Dummy3                  As Word
    Dim Dummy4                  As Byte
    
    Dim dFreqM                  As Dword        ' display MHz
    Dim dFreqK                  As Dword        ' display kHz

    Dim dSetupPLL_PLL           As Byte
    Dim bSetupPLL_Mult          As Byte
    Dim dSetupPLL_Num           As Dword
    Dim dSetupPLL_Denom         As Dword
    Dim fSetupPLL_Num           As Float
    Dim fSetupPLL_Denom         As Float


    Dim dSetFrequency           As Dword


    Dim dSetFrequency_PllFreq   As Dword
    Dim dSetFrequency_L         As Dword
    Dim fSetFrequency_F         As Float
    Dim bSetFrequency_Mult      As Byte
    Dim dSetFrequency_Num       As Dword
    Dim dSetFrequency_Denom     As Dword
    Dim dSetFrequency_Divider   As Dword
    
    Dim dTempFreq               As Dword
    Dim Cycles                  As Dword
    Dim Increment               As Word
    Dim SetPort                 As Bit

    
    GoTo Main                                   ' Jump over the subroutines
    
'---------------------------------------------------------------------------
$define SI5351A_I2CSendRegister(pReg, pData) '
    bI2CRegister_Reg = pReg                  '
    bI2CRegister_Data = pData                '
    GoSub _SI5351A_I2CSendRegister




_SI5351A_I2CSendRegister:
    BStart
    BusOut cI2C_WRITE
    BusOut bI2CRegister_Reg
    BusOut bI2CRegister_Data
    BStop
Return


'---------------------------------------------------------------------------
$define SI5351A_I2CReadRegister(pReg, pData)'
    bI2CRegister_Reg = pReg                 '
    GoSub _SI5351A_I2CReadRegister          '
    pData = bI2CRegister_Data




_SI5351A_I2CReadRegister:
    BStart
    BusOut cI2C_WRITE
    BusOut bI2CRegister_Reg
    BReStart
    BusOut cI2C_READ
    bI2CRegister_Data = BusIn
    BusNack
    BStop
Return


'---------------------------------------------------------------------------
' Set up specified PLL with mult, num and denom
' pMult is 15..90
' pNum is 0..1,048,575 ($FFFFF)
' pDenom is 0..1,048,575 ($FFFFF)
'
$define SI5351A_SetupPLL(pPll, pMult, pNum, pDenom)'
    dSetupPLL_PLL = pPll      '
    bSetupPLL_Mult = pMult    '
    dSetupPLL_Num = pNum      '
    dSetupPLL_Denom = pDenom  '
    GoSub _SI5351A_SetupPLL




_SI5351A_SetupPLL:
    fSetupPLL_Num = dSetupPLL_Num
    fSetupPLL_Denom = dSetupPLL_Denom
    dP1 = (128 * (fSetupPLL_Num / fSetupPLL_Denom))
    dP1 = ((128 * bSetupPLL_Mult) + dP1 - 512)
    dP2 = ((128 * (fSetupPLL_Num) / fSetupPLL_Denom))
    dP2 = ((128 * dSetupPLL_Num) - (dSetupPLL_Denom * dP2))
    dP3 = dSetupPLL_Denom




    SI5351A_I2CSendRegister(dSetupPLL_PLL, dP3.Byte1)
    SI5351A_I2CSendRegister(dSetupPLL_PLL + 1, dP3.Byte0)
    SI5351A_I2CSendRegister(dSetupPLL_PLL + 2, dP1.Byte2 & $03) '(dP1 & $00030000) >> 16)
    SI5351A_I2CSendRegister(dSetupPLL_PLL + 3, dP1.Byte1)
    SI5351A_I2CSendRegister(dSetupPLL_PLL + 4, dP1.Byte0)
    SI5351A_I2CSendRegister(dSetupPLL_PLL + 5, ((dP3 & $000F0000) >> 12) | (dP2.Byte2 & $0F)) '((dP2 & $000F0000) >> 16))
    SI5351A_I2CSendRegister(dSetupPLL_PLL + 6, dP2.Byte1)
    SI5351A_I2CSendRegister(dSetupPLL_PLL + 7, dP2.Byte0)
Return




'---------------------------------------------------------------------------
' Set up MultiSynth with integer divider and R divider
' R divider is the bit value which is OR'ed onto the appropriate register, it is a $define
'
$define SI5351A_SetupMultisynth(pSynth, pDivider, pDiv) '
    bSetupMultisynth_Synth = pSynth     '
    dSetupMultisynth_Divider = pDivider '
    bSetupMultisynth_Div = pDiv         '
    GoSub _SI5351A_SetupMultisynth




_SI5351A_SetupMultisynth:
    dP1 = (128 * dSetupMultisynth_Divider) - 512
    dP2 = 0                                         ' dP2 = 0, dP3 = 1 forces an integer value for the divider
    dP3 = 1




    SI5351A_I2CSendRegister(bSetupMultisynth_Synth,     dP3.Byte1)
    SI5351A_I2CSendRegister(bSetupMultisynth_Synth + 1, dP3.Byte0)
    SI5351A_I2CSendRegister(bSetupMultisynth_Synth + 2, (dP1.Byte2 & $03) | bSetupMultisynth_Div) '((dP1 & $00030000) >> 16) | bSetupMultisynth_Div)
    SI5351A_I2CSendRegister(bSetupMultisynth_Synth + 3, dP1.Byte1)
    SI5351A_I2CSendRegister(bSetupMultisynth_Synth + 4, dP1.Byte0)
    SI5351A_I2CSendRegister(bSetupMultisynth_Synth + 5, ((dP3 & $000F0000) >> 12) | (dP2.Byte2 & $0F)) '((dP2 & $000F0000) >> 16))
    SI5351A_I2CSendRegister(bSetupMultisynth_Synth + 6, dP2.Byte1)
    SI5351A_I2CSendRegister(bSetupMultisynth_Synth + 7, dP2.Byte0)
Return

'The following is unused but included to show how to control outputs
''---------------------------------------------------------------------------
'' Switches off Si5351a output
'' Example: SI5351A_OutputOff(cSI_CLK0_CONTROL) will switch off output CLK0
''
'$define SI5351A_OutputOff(pClk)   '
'    bOutputOff_Clk = pClk         '
'    GoSub _SI5351A_OutputOff


'_SI5351A_OutputOff:
'    SI5351A_I2CSendRegister(bOutputOff_Clk, $80)        ' Refer to SiLabs AN619 to see bit values - $80 turns off the output stage
'    BStop
'Return


'---------------------------------------------------------------------------
' Set CLK0 output ON and to the specified frequency
' Frequency is in the range 1MHz to 150MHz
' Example: SI5351A_SetFrequency(10000000) will set output CLK0 to 10MHz

$define SI5351A_SetFrequency(pFrequency) '
    dSetFrequency = pFrequency           '
    GoSub _SI5351A_SetFrequency


_SI5351A_SetFrequency:
    dSetFrequency_Divider = 900000000 / dSetFrequency                   ' Calculate the division ratio. 900,000,000 is the maximum internal
    If (dSetFrequency_Divider // 2) > 0 Then Dec dSetFrequency_Divider  ' Ensure an even integer division ratio


    dSetFrequency_PllFreq = dSetFrequency_Divider * dSetFrequency       ' Calculate the pllFrequency: the dSetFrequency_Divider * desired output frequency


    bSetFrequency_Mult = dSetFrequency_PllFreq / cXTAL_FREQ             ' Determine the multiplier to get to the required pllFrequency
    
    dSetFrequency_L = dSetFrequency_PllFreq // cXTAL_FREQ               ' It has three parts:
    
    fSetFrequency_F = dSetFrequency_L                                   ' bSetFrequency_Mult is an integer that must be in the range 15..90
    fSetFrequency_F = fSetFrequency_F * 1048575                         ' dSetFrequency_Num and dSetFrequency_Denom are the fractional parts, the numerator and denominator
    fSetFrequency_F = fSetFrequency_F / cXTAL_FREQ                      ' each is 20 bits (range 0..1048575)
    
    dSetFrequency_Num = fSetFrequency_F                                 ' the actual multiplier is  bSetFrequency_Mult + dSetFrequency_Num / dSetFrequency_Denom
    
    dSetFrequency_Denom = 1048575                                       ' For simplicity we set the denominator to the maximum 1048575



' Set up PLL A or PLL B with the calculated multiplication ratio
    If SetPort = 0 Then                                                 'setup PLLA to output on CLK0
    SI5351A_SetupPLL(cSI_SYNTH_PLL_A, bSetFrequency_Mult, dSetFrequency_Num, dSetFrequency_Denom)
    SI5351A_SetupMultisynth(cSI_SYNTH_MS_0, dSetFrequency_Divider, cSI_R_DIV_1)
    SI5351A_I2CSendRegister(cSI_PLL_RESET, $A0)
    SI5351A_I2CSendRegister(cSI_CLK0_CONTROL, $4C | cSI_CLK_SRC_PLL_A)          '2mA or 0dB power %01001100
    Else                                                                'setup PLLB to output on CLK1
    SI5351A_SetupPLL(cSI_SYNTH_PLL_B, bSetFrequency_Mult, dSetFrequency_Num, dSetFrequency_Denom)
    SI5351A_SetupMultisynth(cSI_SYNTH_MS_1, dSetFrequency_Divider, cSI_R_DIV_1)
    SI5351A_I2CSendRegister(cSI_PLL_RESET, $A0)
    SI5351A_I2CSendRegister(cSI_CLK1_CONTROL, $4C | cSI_CLK_SRC_PLL_B)          '2mA or 0dB power %01001100
    EndIf
Return

'use integers to display frequency to overcome float approximations. This sample program does not print CLK1 freq to LCD
DisplayFreq:       
     dFreqM=dTempFreq / 1000000
     dFreqK=dTempFreq - (dFreqM * 1000000)
     If dFreqK < 10 Then 
        Print At 2,1,Dec dFreqM,".00000",Dec dFreqK," MHz   " 
        Return
     EndIf   
     If dFreqK < 100 Then 
        Print At 2,1,Dec dFreqM,".0000",Dec dFreqK," MHz   " 
        Return
     EndIf   
     If dFreqK < 1000 Then 
        Print At 2,1,Dec dFreqM,".000",Dec dFreqK," MHz  " 
        Return
     EndIf   
     If dFreqK < 10000 Then 
        Print At 2,1,Dec dFreqM,".0",Dec dFreqK," MHz  " 
        Return
     EndIf   
     If dFreqK < 100000 Then 
        Print At 2,1,Dec dFreqM,".0",Dec dFreqK," MHz  " 
        Return
     EndIf   
     Print At 2,1,Dec dFreqM,".",Dec dFreqK," MHz  "  
Return


'----------------------------------------------------------------------------------------------------------
Main:
    DelayMS 500
    Clear
    NoOfFreq = (NoOfFreq - 1)*4                    'determines the rollover in the button pushes
    Print At 1,1, "Frequency "
'first setup CLK1
    dSetFrequency = 12150000                       'set frequency for CLK1
    SetPort = 1                                    'switch to steer to appropriate setup
    SI5351A_SetFrequency(dSetFrequency)
    DelayMS 1000
'second setup the CLK0 with EEDATA setting
    Increment = 0
    dSetFrequency = ERead Start_Freq                'set the initial frequency from the EEDATA
    SetPort = 0
'main loop to change CLK) from EEDATA
SetFreq:    
    dTempFreq = dSetFrequency
    GoSub DisplayFreq
    
    SI5351A_SetFrequency(dSetFrequency)

    ButtonGoto:                                     'use eedata as a circular source
    If Up=1 And Down=1 Then GoTo ButtonGoto         'wait for button press
    If Up=0 Then
       If Increment = NoOfFreq Then                 'rollover to bottom of eedata table
          Increment = 0
       Else   
          Increment = Increment + 4
       EndIf   
    Else
       If Increment = 0 Then 
          Increment = NoOfFreq                      'rollover to top of eedata table
       Else   
          Increment = Increment - 4
       EndIf   
    EndIf   
       
    dSetFrequency = ERead Start_Freq + Increment    'set new frequency
    DelayMS 500
    GoTo SetFreq   

